import { createRequire } from 'module';
var require = createRequire(import.meta['url']);

var __require = /* @__PURE__ */ ((x) => typeof require !== "undefined" ? require : typeof Proxy !== "undefined" ? new Proxy(x, {
  get: (a, b) => (typeof require !== "undefined" ? require : a)[b]
}) : x)(function(x) {
  if (typeof require !== "undefined")
    return require.apply(this, arguments);
  throw Error('Dynamic require of "' + x + '" is not supported');
});

// ../../node_modules/.pnpm/@modern-js+module-tools@2.48.3/node_modules/@modern-js/module-tools/shims/esm.js
import { fileURLToPath } from "url";
import path from "path";

// src/index.ts
import { deepmerge } from "@rsbuild/shared";
import { VueLoaderPlugin } from "vue-loader";

// src/splitChunks.ts
import {
  isPlainObject,
  createCacheGroups
} from "@rsbuild/shared";
var applySplitChunksRule = (api, options = {
  vue: true,
  router: true
}) => {
  api.modifyBundlerChain((chain) => {
    const config = api.getNormalizedConfig();
    if (config.performance.chunkSplit.strategy !== "split-by-experience") {
      return;
    }
    const currentConfig = chain.optimization.splitChunks.values();
    if (!isPlainObject(currentConfig)) {
      return;
    }
    const extraGroups = {};
    if (options.vue) {
      extraGroups.vue = ["vue", "vue-loader"];
    }
    if (options.router) {
      extraGroups.router = ["vue-router"];
    }
    if (!Object.keys(extraGroups).length) {
      return;
    }
    chain.optimization.splitChunks({
      ...currentConfig,
      // @ts-expect-error Rspack and Webpack uses different cacheGroups type
      cacheGroups: {
        ...currentConfig.cacheGroups,
        ...createCacheGroups(extraGroups)
      }
    });
  });
};

// src/index.ts
function pluginVue2(options = {}) {
  return {
    name: "rsbuild:vue2",
    setup(api) {
      api.modifyBundlerChain((chain, { CHAIN_ID }) => {
        chain.resolve.extensions.add(".vue");
        if (!chain.resolve.alias.get("vue$")) {
          chain.resolve.alias.set("vue$", "vue/dist/vue.runtime.esm.js");
        }
        const vueLoaderOptions = deepmerge(
          {
            compilerOptions: {
              preserveWhitespace: false
            },
            experimentalInlineMatchResource: true
          },
          options.vueLoaderOptions ?? {}
        );
        chain.module.rule(CHAIN_ID.RULE.VUE).test(/\.vue$/).use(CHAIN_ID.USE.VUE).loader(__require.resolve("vue-loader")).options(vueLoaderOptions);
        chain.plugin(CHAIN_ID.PLUGIN.VUE_LOADER_PLUGIN).use(VueLoaderPlugin);
      });
      applySplitChunksRule(api, options.splitChunks);
    }
  };
}
export {
  pluginVue2
};
